import requests
import json
from pprint import pprint
import base64
from jinja2 import Template
import codecs
# from bs4 import BeautifulSoup
import openpyxl
import sys


domain = 'tox1i0lgjy5s'
app_id = 481
api_token = ""
indexName = '一覧2'


def encode64(id, pw):
    ostr = '{}:{}'.format(id, pw)
    bstr = base64.b64encode(ostr.encode())
    str = bstr.decode()
    return str


authToken = encode64('18648981@alumni.tus.ac.jp', 'yokomimi01')

headers = {"Content-Type": "application/json",
           "X-Cybozu-Authorization": authToken,
           "Authorization": "Basic {}".format(authToken),
           }


def app_deploy(app_id2):
    """
    状態を運用開始前から運用中にする
    """

    url = "https://{}.cybozu.com/k/v1/preview/app/deploy.json".format(domain)

    params = {
        "apps": [
            {
                "app": app_id2,
            },
        ],
    }

    resp = requests.post(url, json=params, headers=headers)
    dictReturn = json.loads(resp.text)

    pprint(dictReturn)


def getViews():
    """kintoneのビューを取得する"""

    url = f"https://{domain}.cybozu.com/k/v1/app/views.json"
    params = {"app": app_id}

    resp = requests.get(url, json=params, headers=headers)
    dictReturn = json.loads(resp.text)

    return dictReturn


def updateView(views):

    url = f"https://{domain}.cybozu.com/k/v1/preview/app/views.json"
    params = {
        "app": app_id,
        "views": {
            indexName: views,
        },
    }

    resp = requests.put(url, json=params, headers=headers)
    dictReturn = json.loads(resp.text)
    pprint(dictReturn)


def extract_div_content(html_text):
    """HTMLからdivの内容を取得する"""

    soup = BeautifulSoup(html_text, 'html.parser')
    div_content = str(soup.find('div', id='a'))

    return div_content


def extractHtml(dictView,  html):
    """ビューのHTMLを取得する"""

    view = dictView["views"][indexName]
    view['html'] = html

    return view


def getLayout(app_id3):

    url = f"https://{domain}.cybozu.com/k/v1/app/form/layout.json"
    params = {
        "app": app_id3,
    }

    resp = requests.get(url, json=params, headers=headers)
    dictReturn = json.loads(resp.text)
    pprint(dictReturn)

    with open('laytou.json', 'w', encoding='utf-8') as fp:
        json.dump(dictReturn, fp, ensure_ascii=False, indent=4)


def setLayout(app_id2, listFields):

    with open('laytou.json', 'r', encoding='utf-8') as fp:
        listData = json.load(fp)

    params = {}
    params['app'] = app_id2
    # params['layout'] = listData['layout']
    params['layout'] = listFields

    # pprint(listData)

    url = f"https://{domain}.cybozu.com/k/v1/preview/app/form/layout.json"
    # params = {
    #     "app": 481,
    # }

    resp = requests.put(url, json=params, headers=headers)
    dictReturn = json.loads(resp.text)
    pprint(dictReturn)

    # with open('laytou.json', 'w', encoding='utf-8') as fp:
    #     json.dump(dictReturn, fp, ensure_ascii=False, indent=4)


def getFields():

    url = f"https://{domain}.cybozu.com/k/v1/app/form/fields.json"
    params = {
        "app": app_id,
    }

    resp = requests.get(url, json=params, headers=headers)
    dictReturn = json.loads(resp.text)
    # pprint(dictReturn)

    listFields = []
    for key, val in dictReturn['properties'].items():
        # pprint(f"{val['code']} {val['type']}")
        item = {
            "type": "ROW",
            "fields": [
                {
                    "type": "LABEL",
                    "label": "<div>ああああああああああああああああああああああああああ<br>ああああああああああああああああああああああああああああああああああ<br>あああああああああああああああああああああああああ<br>ああああああああああああああああああああああああああああああああ<br>あああああああああああああああああああああああああああああああああああああ<br>あああああああああああああああああああああああ</div>",
                    "size": {
                        "width": "300"
                    }
                },
                {
                    "type": val['type'],
                    "code": val['code'],
                    "size": {
                        "width": "300"
                    }
                }
            ]
        }

        if val['type'] not in ['CATEGORY', 'STATUS_ASSIGNEE', 'CREATOR', 'STATUS', 'RECORD_NUMBER', 'MODIFIER', 'CREATED_TIME', 'UPDATED_TIME']:
            listFields.append(item)
    # dictOut = {
    #     "layout": listFields
    # }

    # pprint(dictOut)

    with open('fields.json', 'w', encoding='utf-8') as fp:
        json.dump(dictReturn, fp, ensure_ascii=False, indent=4)
    with open('listFields.json', 'w', encoding='utf-8') as fp:
        json.dump(listFields, fp, ensure_ascii=False, indent=4)

    return listFields


def readExcel():

    wb = openpyxl.load_workbook('bcp.xlsx')
    sheet = wb['Sheet2']
    output_dict = {}
    for row_idx, row in enumerate(sheet.iter_rows(values_only=True), 1):

        type0 = row[0]
        label0 = row[1]

        type1 = row[2]
        code1 = row[3]
        attr1 = row[4]
        # print(f"{type1}, {code1}, {attr1}")
        # for col_idx, cell in enumerate(row, 1):
        #     if cell is not None:
        #         print(f"Row {row_idx}, Column {col_idx}: {cell}")

        if type1 != None:
            key = f'C{code1}'
            index = 0
            opt = {attr1: {"label": attr1, "index": index}}
            output_dict[key] = {"type":  type1,
                                "code":  key, "label":  key, "options": opt, "align": "VERTICAL"}
        else:
            # print("type1 is None")
            if attr1 != None:
                index += 1
                # opt = {attr1: {"label": attr1, "index": index, "value": attr1}}
                output_dict[key]["options"][attr1] = {
                    "label": attr1, "index": index}

    # pprint(output_dict)
    with open('output2.json', 'w', encoding='utf-8') as fp:
        json.dump(output_dict, fp, ensure_ascii=False, indent=4)

    return output_dict


def create_app(name):
    """
    新規アプリ作成
    """

    url = "https://{}.cybozu.com/k/v1/preview/app.json".format(domain)
    params = {"name": name}

    resp = requests.post(url, json=params, headers=headers)
    dctData = json.loads(resp.text)
    # pprint(dctData)
    app_id = dctData['app']

    return app_id


def add_field(app_id, dictParam):
    """
    フィールドの追加
    """

    url = "https://{}.cybozu.com/k/v1/preview/app/form/fields.json".format(
        domain)

    params = {
        "app": app_id,
        "properties": dictParam
    }
    pprint(params)

    resp = requests.post(url, json=params, headers=headers)
    print(resp.text)


def readExcel2():
    wb = openpyxl.load_workbook('bcp2.xlsx')
    ws = wb['Sheet1']

    listOut = []
    for row in ws.values:
        print(row)
        listOut.append(list(row))

    wb.close()

    return listOut


def getFieldsLayout(listData):

    # listAll = []
    dictRow = {}
    dictFields = {}
    for row in listData:
        no = row[0]
        type1 = row[1]
        code1 = row[2]
        attr1 = row[3]
        type2 = row[4]
        code2 = row[5]
        attr2 = row[6]
        type3 = row[7]
        code3 = row[8]
        attr3 = row[9]

        listRowData = []
        if type1 == 'LABEL':

            label_data2 = ""
            if attr1 != None:
                for i in range(0, len(attr1), 30):
                    label_data2 += attr1[i:i+30] + "<br>"
                label_data2 = "<div>" + label_data2 + "</div>"
            label_data2 = f"<font size='6' color='red' underline='true'>{label_data2}</font>"
            item = {
                "type": "LABEL",
                        "label": label_data2,
                        "size": {
                            "width": "500"
                        }
            }
            listRowData.append(item)

        # if type2 == 'RADIO_BUTTON':

        #     item = {
        #         "type": "RADIO_BUTTON",
        #                 "label": attr1,
        #                 "size": {
        #                     "width": "500"
        #                 }
        #     }
        #     listRowData.append(item)

        dictLayout = {
            "type": "ROW",
            "fields": listRowData
        }

        if len(listRowData) >= 1:
            # listAll.append(dictLayout)
            # listLayout.append(dictLayout)
            dictRow[no] = dictLayout

        if type1 != None:
            key = f'C{code2}'
            index = 0
            opt = {attr2: {"label": attr2, "index": index}}
            dictFields[key] = {"type":  type2,
                               "code":  key, "label":  key, "options": opt, "align": "VERTICAL", "no": no}
        else:
            # print("type1 is None")
            if attr2 != None:
                index += 1
                # opt = {attr1: {"label": attr1, "index": index, "value": attr1}}
                dictFields[key]["options"][attr2] = {
                    "label": attr2, "index": index}

    dictOut = {}
    dictFields2 = {}
    for key, val in dictFields.items():
        val2 = val.copy()
        del val2['no']
        if val['type'] == 'RADIO_BUTTON':
            dictOut[val['no']] = val
            dictFields2[key] = val2

    listRow3 = []
    for key, val in dictRow.items():
        dictRow2 = {}
        if key in dictOut:
            dictTemp = {}
            dictTemp['code'] = dictOut[key]['code']
            dictTemp['type'] = dictOut[key]['type']
            dictTemp['size'] = {"width": "500"}
            val['fields'].append(dictTemp)
        dictRow2['type'] = 'ROW'
        dictRow2['fields'] = val['fields']
        listRow3.append(dictRow2)

    # pprint(val)
    pprint(dictOut)
    # pprint('---------------------')

    # pprint(dictRow)
    # print('-------------------------------')
    # pprint(dictOut)
    with open('layout5.json', 'w', encoding='utf-8') as fp:
        json.dump(listRow3, fp, ensure_ascii=False, indent=4)
    with open('fields5.json', 'w', encoding='utf-8') as fp:
        json.dump(dictFields2, fp, ensure_ascii=False, indent=4)


if __name__ == "__main__":

    # getLayout(538)
    # sys.exit()


    listData = readExcel2()
    getFieldsLayout(listData)
    with open('fields5.json', 'r', encoding='utf-8') as fp:
        dictFields = json.load(fp)

    with open('layout5.json', 'r', encoding='utf-8') as fp:
        layout5 = json.load(fp)

    # pprint(dictFields)
    # # sys.exit()

    # layout_data = [
    #     [
    #         {
    #             'type': 'LABEL',
    #             'label': 'あああああああああああああああ'
    #         },
    #         {
    #             'type': 'RADIO_BUTTON',
    #             'code': 'RADIO_BUTTON',
    #             'size': {
    #                 'width': '500'
    #             }
    #         }
    #     ],
    # ]

    # label_data = "あああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああああ"
    # label_data2 = ""
    # for i in range(0, len(label_data), 30):
    #     label_data2 += label_data[i:i+30] + "<br>"
    # label_data2 = "<div>" + label_data2 + "</div>"

    app_id2 = create_app('BCPアプリ2')
    # print(f"app_id: {app_id}")

    # dictData = readExcel()
    # dictOut = {}
    # listLayout = []
    # for key, val in dictData.items():
    #     if val['type'] == 'RADIO_BUTTON':
    #         dictOut[key] = val
    #         dictLayout = {
    #             "type": "ROW",
    #             "fields": [
    #                 {
    #                     "type": "LABEL",
    #                     "label": label_data2,
    #                     "size": {
    #                             "width": "500"
    #                     }
    #                 },
    #                 {
    #                     "type": "RADIO_BUTTON",
    #                     "code": key,
    #                     "size": {
    #                         "width": "500"
    #                     }
    #                 }
    #             ]
    #         }
    #         listLayout.append(dictLayout)

    #     # print(f"{key} {val['type']}")
    # with open('output3.json', 'w', encoding='utf-8') as fp:
    #     json.dump(dictOut, fp, ensure_ascii=False, indent=4)

    # params = {
    #     "app": 1,
    #     "properties": dictOut
    # }
    add_field(app_id2, dictFields)

    # with open('layout2.json', 'r', encoding='utf-8') as fp:
    #     listLayout = json.load(fp)

    # setLayout(listLayout)

    # pprint(dictOut)

    # fields = getFields()
    # pprint(fields)
    # # getLayout()
    setLayout(app_id2, layout5)
    app_deploy(app_id2)

    # with open('template.html', 'r', encoding='utf-8') as file:
    #     html = file.read()

    # template = Template(html)
    # htmlReplaced = template.render(name='鈴木xxx')
    # htmlTable = extract_div_content(htmlReplaced)

    # dictView = getViews()
    # views = extractHtml(dictView,  htmlTable)
    # updateView(views)
    # app_deploy()

    print('---------完了---------')
