import requests
import json
from pprint import pprint
import sys
import os
import openpyxl
import base64


def encode64(id, pw):
    ostr = '{}:{}'.format(id, pw)
    bstr = base64.b64encode(ostr.encode())
    str = bstr.decode()
    return str


authToken = encode64('18648981@alumni.tus.ac.jp', 'yokomimi01')

headers = {"Content-Type": "application/json",
           "X-Cybozu-Authorization": authToken,
           "Authorization": "Basic {}".format(authToken),
           }
domain = 'tox1i0lgjy5s'


def create_app(name):
    """
    新規アプリ作成
    """

    url = "https://{}.cybozu.com/k/v1/preview/app.json".format(domain)
    params = {"name": name}

    resp = requests.post(url, json=params, headers=headers)
    dctData = json.loads(resp.text)
    pprint(dctData)
    app_id = dctData['app']

    return app_id


def add_field(app_id, dictParam):
    """
    フィールドの追加
    """

    url = "https://{}.cybozu.com/k/v1/preview/app/form/fields.json".format(
        domain)

    params = {
        "app": app_id,
        "properties": dictParam
    }

    resp = requests.post(url, json=params, headers=headers)
    print(resp.text)


def app_deploy(app_id):
    """
    状態を運用開始前から運用中にする
    """

    url = "https://{}.cybozu.com/k/v1/preview/app/deploy.json".format(domain)

    params = {
        "apps": [
            {
                "app": app_id,
            },
        ],
    }

    resp = requests.post(url, json=params, headers=headers)
    print(resp.text)


def read_excel(excel_file):

    wb = openpyxl.load_workbook(excel_file)
    ws = wb['Sheet1']

    dictParam = {}

    for row in range(2,  ws.max_row + 1):
        key = ws.cell(row=row, column=1).value
        type = ws.cell(row=row, column=2).value
        if type == 'DROP_DOWN':
            dictOptions = {}
            for cnt in range(0, 100):
                option = ws.cell(row=row, column=cnt+4).value
                if option == None:
                    break
                else:
                    dictOptions[option] = {
                        "label": option,
                        "index": cnt
                    }
            # pprint(dictOptions)
            dictParam[key] = {
                "type": type,
                "code": key,
                "label": key,
                "options": dictOptions
            }
        else:
            dictParam[key] = {
                "type": type,
                "code": key,
                "label": key
            }

    return dictParam


if __name__ == "__main__":

    excel_file = '自動作成アプリ2.xlsx'

    basename_without_ext = os.path.splitext(os.path.basename(excel_file))[0]
    print(basename_without_ext)

    app_id = create_app(basename_without_ext)
    dictParam = read_excel(excel_file)
    pprint(dictParam)
    with open('output4.json', 'w', encoding='utf-8') as fp:
        json.dump(dictParam, fp, ensure_ascii=False, indent=4)


    add_field(app_id, dictParam)
    app_deploy(app_id)
